package com.book.controller;

import static org.axonframework.commandhandling.GenericCommandMessage.asCommandMessage;

import org.axonframework.commandhandling.CommandBus;
import org.axonframework.commandhandling.model.Repository;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.book.command.UpdateBookCommand;
import com.book.domain.Book;

@RestController
public class BooksController {

	private CommandBus commandBus;
	private Repository<Book> jpaRepo;

	public BooksController(CommandBus commandBus, Repository<Book> jpaRepo) {
		this.commandBus = commandBus;
		this.jpaRepo = jpaRepo;
	}

	@RequestMapping(value = "/create", method = RequestMethod.GET)
	@Transactional
	public void createBook() {
		Book book = (Book) jpaRepo.load("1");
		commandBus.dispatch(asCommandMessage(new UpdateBookCommand(book.getBookId(), "test123", 10)));
	}

}
