package com.book.repository.listener;

import org.axonframework.eventhandling.EventHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.book.event.BookAddedEvent;
import com.book.event.BookUpdatedEvent;
import com.book.repository.BookRepository;
import com.book.repository.entity.BookEntity;

@Component
public class BookEventListener {

	private BookRepository repository;
	
	@Autowired
    public void setRepository(BookRepository repository) {
        this.repository = repository;
    }
	
	@EventHandler
	public void onAddBookEvent(BookAddedEvent event){
		repository.save(new BookEntity(event.getBookId(),event.getBookName(),event.getPrice()));
	}
	
	@EventHandler
	public void onUpdateBookEvent(BookUpdatedEvent  event){
		BookEntity bookEntity=repository.findOne(event.getBookId());
		bookEntity.setBookName(event.getBookName());
		bookEntity.setPrice(event.getPrice());
		repository.save(bookEntity);
	}
}
