package com.book;

import org.axonframework.test.FixtureConfiguration;
import org.axonframework.test.Fixtures;
import org.junit.Before;
import org.junit.Test;

import com.book.command.AddBookCommand;
import com.book.command.UpdateBookCommand;
import com.book.domain.Book;
import com.book.event.BookAddedEvent;
import com.book.event.BookUpdatedEvent;

public class BookTestCases {

	private FixtureConfiguration<Book> fixture;

	@Before
	public void setUp() throws Exception {
		fixture = Fixtures.newGivenWhenThenFixture(Book.class);
	}
	
	@Test
	public void testAddBookCommand()throws Exception{
		fixture.givenNoPriorActivity().
		when(new AddBookCommand(1L, "test", 10))
		.expectEvents(new BookAddedEvent(1L, "test", 10));
	}

	@Test
	public void testUpdateBookEvent(){
		fixture.given(new BookAddedEvent(1L, "test", 10))
		.when(new UpdateBookCommand(1L, "test", 10))
		.expectEvents(new BookUpdatedEvent(1L, "test", 10));
	}
	
}
